Index: /branches/2.2/infodist/ultima-revisao-svn.php
===================================================================
--- /branches/2.2/infodist/ultima-revisao-svn.php	(revision 3984)
+++ /branches/2.2/infodist/ultima-revisao-svn.php	(revision 3984)
@@ -0,0 +1,1 @@
+<?php $ultima_revisao ="2.2 R3556" ?>
Index: /branches/2.2/security/classes/funcoes_auxiliares.php
===================================================================
--- /branches/2.2/security/classes/funcoes_auxiliares.php	(revision 3563)
+++ /branches/2.2/security/classes/funcoes_auxiliares.php	(revision 3984)
@@ -1,5 +1,5 @@
 <?php
 //  Conjunto de funcoes de apoio as Classes de tratamento do certificado digital.
-	
+
 		function pega_path($chaves,$linha)
 		{
@@ -33,5 +33,5 @@
 			return $ret;
 		}
-	
+
 	function ler_certificados_CAS($path,$flag=false)
             {
@@ -98,7 +98,7 @@
                     return  $aux_xml;
 		}
-		
-		
-	function data_hora ($valor) 
+
+
+	function data_hora ($valor)
 	{
 		$year  = substr($valor, 0, 2);
@@ -123,6 +123,6 @@
 		$N = $lista[rand(0,count($lista)-1)].date('U').$lista[rand(0,count($lista)-1)].RAND(12345,9999999999).$lista[rand(0,count($lista)-1)].$lista[rand(0,count($lista)-1)].RAND(12345,9999999999).'.tmp';
 		$aux = $GLOBALS['dirtemp'].'/'.$N;;
-	        array_push($tab_arqs ,$aux); 
-		return  $aux;		
+	        array_push($tab_arqs ,$aux);
+		return  $aux;
 	}
 
@@ -138,18 +138,27 @@
 			return $ret;
 	}
-	
-	
+
+
 	function deleta_arquivos_temporarios($tab_arqs)
 	{
 		foreach($tab_arqs as $arquivo )
-			{ 
+			{
 				if(file_exists($arquivo))
 					{
 						unlink($arquivo);
 					}
-			}	
-	}
-
-
+			}
+	}
+
+        function troca_espaco_por_mais($pem_data)
+        {
+            $begin = "CERTIFICATE-----";
+            $end   = "-----END";
+            $aux = substr($pem_data, strpos($pem_data, $begin)+strlen($begin));
+            $aux = substr($aux, 0, strpos($aux, $end));
+            $aux = strtr($aux,' ','+');
+            $aux = '-----BEGIN CERTIFICATE-----'.$aux.'-----END CERTIFICATE-----';
+            return $aux;
+        }
        	function verificaopenssl()
 	{
@@ -165,5 +174,5 @@
        	function print_hex($value)
 	{
-		$tab_val = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'); 
+		$tab_val = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
 		for($A=0;$A<strlen($value);$A++)
 			{
@@ -184,5 +193,5 @@
 		# Testa se tamanho menor/igual a 127 bytes..
 		# Neste caso $len  ja he o tamanho do conteudo
-		if ($len & 0x80) 
+		if ($len & 0x80)
 			{
 				# Testa se tamanho indefinido (nao deve ocorrer em uma codificação DER.
@@ -193,10 +202,10 @@
 						$bytes = 0;
 					}
-				else					
-					{
-						# he tamanho definido. diz quantos bytes formam o tamanho.... 
+				else
+					{
+						# he tamanho definido. diz quantos bytes formam o tamanho....
 						$bytes = $len & 0x0f;
 						$len = 0;
-						for ($i = 0; $i < $bytes; $i++) 
+						for ($i = 0; $i < $bytes; $i++)
 							{
 								$len = ($len << 8) | ord($data[$i + 2]);
@@ -205,8 +214,8 @@
 			}
 	}
-	
+
 	function xBase128($ab,$q,$flag )
 	{
-		$abc = $ab; 
+		$abc = $ab;
 		if( $q > 127 )
 			{
@@ -256,9 +265,9 @@
 		return $value;
 	}
-	
-	
-	
+
+
+
         function Crl_parseASN($data,$context_especific = false)
-	{  
+	{
         // Tabela de OIDs .
                	$_oids = array(
@@ -290,5 +299,5 @@
 			'1.2.840.10040.4.3' => 'id-dsa-with-sha-1',
 			'1.3.6.1.5.5.7.3.2' => 'id_kp_clientAuth',
-			'1.3.6.1.5.5.7.3.4' => 'id_kp_securityemail',	
+			'1.3.6.1.5.5.7.3.4' => 'id_kp_securityemail',
 			'1.3.6.1.5.5.7.2.1' => 'id_certificatePolicies',
 			'2.16.840.1.113730.1.1' => 'netscape-cert-type',
@@ -300,6 +309,6 @@
 			'2.16.840.1.113730.1.12' => 'netscape-ssl-server-name',
 			'2.16.840.1.113730.1.13' => 'netscape-comment',
-			'2.16.76.1.2.1' => 'A1',	
-			'2.16.76.1.2.3' => 'A3',	
+			'2.16.76.1.2.1' => 'A1',
+			'2.16.76.1.2.3' => 'A3',
 			'2.16.76.1.2.1.16' => 'Certification Practice Statement pointer',
 			'2.16.76.1.3.1' => 'Dados do cert parte 1',
@@ -1132,9 +1141,9 @@
 
 		$result = array();
-		
-		while (strlen($data) > 1) 
+
+		while (strlen($data) > 1)
 		{
 			$class = ord($data[0]);
-			switch ($class) 
+			switch ($class)
 			{
 				case 0x30:
@@ -1146,5 +1155,5 @@
 					$data = substr($data, 2 + $bytes + $len);
 					$values = Crl_parseASN($sequence_data);
-					if (!is_array($values) || is_string($values[0])) 
+					if (!is_array($values) || is_string($values[0]))
 					{
 						$values = array($values);
@@ -1169,5 +1178,5 @@
 					$result[] = array('boolean (1)' , $boolean_value);
 					break;
-				
+
 				case 0x02:
 					// Integer type
@@ -1188,23 +1197,23 @@
 					{
 						$value = 0;
-						if ($len <= 4) 
+						if ($len <= 4)
 						{
 							// Method works fine for small integers
-							for ($i = 0; $i < strlen($integer_data); $i++) 
+							for ($i = 0; $i < strlen($integer_data); $i++)
 							{
 								$value = ($value << 8) | ord($integer_data[$i]);
 							}
-						} 
-						else 
+						}
+						else
 						{
-							// Method works for arbitrary length integers 
-							if (extension_loaded('bcmath')) 
+							// Method works for arbitrary length integers
+							if (extension_loaded('bcmath'))
 							{
-								for ($i = 0; $i < strlen($integer_data); $i++) 
+								for ($i = 0; $i < strlen($integer_data); $i++)
 								{
 									$value = bcadd(bcmul($value, 256), ord($integer_data[$i]));
 								}
-							} 
-							else 
+							}
+							else
 							{
 								$value = -1;
@@ -1227,5 +1236,5 @@
 
 				case 0x04:
-					// Octetstring type 
+					// Octetstring type
 					$len = ord($data[1]);
 					$bytes = 0;
@@ -1242,5 +1251,5 @@
 					}
 					break;
-					
+
 				case 0x0C:
 					// UTF8 STRING
@@ -1281,10 +1290,10 @@
 					$value = 0;
 					$i = 1;
-					while ($i < strlen($oid_data)) 
+					while ($i < strlen($oid_data))
 					{
 						$value = $value << 7;
 						$value = $value | (ord($oid_data[$i]) & 0x7f);
 
-						if (!(ord($oid_data[$i]) & 0x80)) 
+						if (!(ord($oid_data[$i]) & 0x80))
 						{
 							$plain .= '.' . $value;
@@ -1294,9 +1303,9 @@
 					}
 
-					if (isset($_oids[$plain])) 
+					if (isset($_oids[$plain]))
 					{
 						$result[] =  array('oid(' . $len . '): '  . $plain, $_oids[$plain]);
-					} 
-					else 
+					}
+					else
 					{
 						$result[] = array('oid(' . $len . '): '  . $plain, $plain);
@@ -1313,9 +1322,9 @@
 					$result[] = array('IA5 String (' . $len . ')'  , $string_data);
 					break;
-					
+
 				case 0x12:
 				case 0x14:
-				case 0x15:	
-				case 0x81:			
+				case 0x15:
+				case 0x81:
 					// Character string type
 					$len = ord($data[1]);
@@ -1336,5 +1345,5 @@
 					$result[] = array('string (' . $len . ')'  , print_hex($string_data));
 					break;
-					
+
 				case 0x13:
 				case 0x86:
@@ -1379,5 +1388,5 @@
 					$result[] = array('Context Especific (' . $len . ')' , array(Crl_parseASN($extension_data,true)));
 					break;
-					
+
 				case 0xa3:
 					// Extensions
@@ -1414,6 +1423,6 @@
 
    }
-   
-   function openssl_to_timestamp ($in) 
+
+   function openssl_to_timestamp ($in)
    {
 	$year  = substr($in, 0, 4); /* NOTE: Yes, this returns a two digit year */
@@ -1423,5 +1432,5 @@
         $min   = substr($in, 10, 2);
         $sec   = substr($in, 12, 2);
-    
+
         return gmmktime($hour, $min, $sec, $month, $day, $year);
 	}
@@ -1429,9 +1438,9 @@
 #============================================================================================
 # Transforma o certificado do formato PEM para o formato DER ...
-function pem2der($pem_data) 
+function pem2der($pem_data)
 	{
 		$begin = "CERTIFICATE-----";
 		$end   = "-----END";
-		$pem_data = substr($pem_data, strpos($pem_data, $begin)+strlen($begin));    
+		$pem_data = substr($pem_data, strpos($pem_data, $begin)+strlen($begin));
 		$pem_data = substr($pem_data, 0, strpos($pem_data, $end));
 		$der = base64_decode($pem_data);
@@ -1442,5 +1451,5 @@
 function testa_p7m($msg)
 	{
-		// oids pesquisadas: 
+		// oids pesquisadas:
 		//                                1.2.840.113549.1.7.2     assinatura digital
 		//                                 1.2.840.113549.1.7.3     envelopeddata
@@ -1455,10 +1464,10 @@
 					return 'signature' ;
 			}
-		$oid_hexa = OIDtoHex('1.2.840.113549.1.7.3');  
+		$oid_hexa = OIDtoHex('1.2.840.113549.1.7.3');
 		$partes = explode($oid_hexa,$p7m_formato_der);    // Faz o split pela oid...
 		if(count($partes)>1)
 			{
 					return 'cipher' ;
-			}			
+			}
 		return 'normal';
 	}
@@ -1492,5 +1501,5 @@
 							{
 								$xcv = $xcv2;
-								$data = $xcv . $oid_hexa . $partes[$i];           // reconstroi a sequencia.....	
+								$data = $xcv . $oid_hexa . $partes[$i];           // reconstroi a sequencia.....
 								$ret = parse_sequence($data);
 
@@ -1504,5 +1513,5 @@
 							{
 								$xcv = $xcv3;
-								$data = $xcv . $oid_hexa . $partes[$i];           // reconstroi a sequencia.....	
+								$data = $xcv . $oid_hexa . $partes[$i];           // reconstroi a sequencia.....
 								$ret = parse_sequence($data);
 								if($ret[0] != '')
@@ -1515,5 +1524,5 @@
 							{
 								$xcv = $xcv4;
-								$data = $xcv . $oid_hexa . $partes[$i];           // reconstroi a sequencia.....	
+								$data = $xcv . $oid_hexa . $partes[$i];           // reconstroi a sequencia.....
 								$ret = parse_sequence($data);
 								if($ret[0] != '')
@@ -1521,7 +1530,7 @@
 										$retr[] = $ret;
 										continue;
-									}										
-							}							
-					} 
+									}
+							}
+					}
 			}
 		return $retr;
@@ -1535,8 +1544,8 @@
 		//  OID's PESSOA FISICA = 2.16.76.1.3.1 ,  2.16.76.1.3.6 ,  2.16.76.1.3.5 ,  2.16.76.1.4.n ... as 2.16.1.4.n não são obrigatórias e ão sao tratadas..
 		//
-		//  OID's PESSOA JURIDICA = 2.16.76.1.3.4 ,  2.16.76.1.3.2 , 2.16.76.1.3.3 , 2.16.76.1.3.7 
+		//  OID's PESSOA JURIDICA = 2.16.76.1.3.4 ,  2.16.76.1.3.2 , 2.16.76.1.3.3 , 2.16.76.1.3.7
 		//
-		//  OID's EQUIPAMENTO/APLICAÇÃO = 2.16.76.1.3.8 ,  2.16.76.1.3.3 , 2.16.76.1.3.2 , 2.16.76.1.3.4 
-		//	
+		//  OID's EQUIPAMENTO/APLICAÇÃO = 2.16.76.1.3.8 ,  2.16.76.1.3.3 , 2.16.76.1.3.2 , 2.16.76.1.3.4
+		//
 		//  OID  para logon no NT:  1.3.6.1.4.1.311.20.2.3
 		//
@@ -1552,15 +1561,15 @@
 							       '3'=>array('NIS',11),
 							       '4'=>array('RG',15),
-							       '5'=>array('ORGAOUF',6)),	
+							       '5'=>array('ORGAOUF',6)),
 				     '2.16.76.1.3.5' => array('1'=>array('TITULO',12),
 				                              '2'=>array('ZONA',3),
 							      '3'=>array('SECAO',4),
-							      '4'=>array('TITULO_CIDADE_UF',0)),	
-				     '2.16.76.1.3.6' => array('1'=>array('CADINSS',12)),							      
-				     '2.16.76.1.3.7' => array('1'=>array('CEI',12)),								       
+							      '4'=>array('TITULO_CIDADE_UF',0)),
+				     '2.16.76.1.3.6' => array('1'=>array('CADINSS',12)),
+				     '2.16.76.1.3.7' => array('1'=>array('CEI',12)),
 				     '2.16.76.1.3.8' => array('1'=>array('NOMEEMPRESARIAL',0)),
-				     '1.3.6.1.4.1.311.20.2.3' => array('1'=>array('NTNOMEPRINCIPAL',0)));				     
-				     
-		$resultado = array(); 
+				     '1.3.6.1.4.1.311.20.2.3' => array('1'=>array('NTNOMEPRINCIPAL',0)));
+
+		$resultado = array();
 		$esta_oid = $oids[$oid];
 		$p = 0;
@@ -1575,5 +1584,5 @@
 					{
 						$tamanho = $esta_oid[$i][1];
-					} 
+					}
 				$resultado[$oid][$esta_oid[$i][0]] = substr($valor,$p,$tamanho);
 				// A linha logo abaixo he para manter compatibilidade com versoes anteriores... Sera desativada assim que possivel...
@@ -1583,7 +1592,7 @@
 
 		return $resultado;
-	}  
-
-	
+	}
+
+
 function subjectAltName($xx, $certificado_digital_formato_der)
 	{
@@ -1621,5 +1630,5 @@
 	}
 
-	
+
 function CRLDistributionPointsxx($xx, $certificado_digital_formato_der)
 	{
@@ -1629,6 +1638,6 @@
 		echo '</pre><br/><br/>';
 		exit();
-		
-		
+
+
 		$i=1;
 		if(substr($AUX[0][1][0],0,7) == 'boolean')
@@ -1638,6 +1647,6 @@
 		$AUX1 = $AUX[0][$i][1][1][0];
 		// Pode existir mais de uma crl, mas vamos considerar apenas a primeira.....
-		return array('CRLDISTRIBUTIONPOINTS' => $AUX1[1][0][1][0][1][0][1]);		
-	}	
+		return array('CRLDISTRIBUTIONPOINTS' => $AUX1[1][0][1][0][1][0][1]);
+	}
 
 function CRLDistributionPoints($xx, $certificado_digital_formato_der)
@@ -1664,5 +1673,5 @@
 					  }
 			}
-		
+
 		// Se $ret esta vazio tenta obter crls em outra estrutura(outro layout).
 		if(count($ret) == 0)
@@ -1680,9 +1689,9 @@
 					  }
 			}
-			
+
                 return array('CRLDISTRIBUTIONPOINTS' => $ret);
-	}	
-
-        
+	}
+
+
 function SERIALNUMBER($cert_data,$KK)
 	{
@@ -1692,7 +1701,7 @@
 				$dados['SERIALNUMBER'] = $cert_data[1][0][1][$KK][1];
 			}
-		return $dados;			
-	}
-	
+		return $dados;
+	}
+
 function SUBJECT($cert_data,$KK)
 	{
@@ -1705,12 +1714,12 @@
 			$AUX = explode(':',$dados['SUBJECT']['CN']);
 		$dados['NOME'] = $AUX[0];
-		return $dados;			
-	}
-		
-function ISSUER($cert_data,$KK)		
-	{
-		$dados = array();	
+		return $dados;
+	}
+
+function ISSUER($cert_data,$KK)
+	{
+		$dados = array();
 		$dados['EMISSOR_CAMINHO_COMPLETO']  = array();
-		
+
 		foreach($cert_data[1][0][1][$KK][1] as $AUX2)
 			{
@@ -1718,8 +1727,8 @@
 			}
 		$dados['EMISSOR'] = $dados['EMISSOR_CAMINHO_COMPLETO']['CN'];
-		return $dados;	
-	}		
-
-        
+		return $dados;
+	}
+
+
 function BEFOREAFTER($cert_data,$KK)
 	{
@@ -1735,7 +1744,7 @@
 			{
 				$dados['EXPIRADO'] = false;
-			}	
-		return $dados;		
-		}	
+			}
+		return $dados;
+		}
 
 
@@ -1758,10 +1767,10 @@
 				$dados['AUTHORITYKEYIDENTIFIER'] = "auto-assinado";
 			}
-		return $dados;			
-	}
-	
+		return $dados;
+	}
+
 function KEYUSAGE($xx, $certificado_digital_formato_der)
 	{
-		$KeyUsage= array( 0x80 => 'digitalSignature', 
+		$KeyUsage= array( 0x80 => 'digitalSignature',
 			      0x40 => 'nonRepudiation',
                               0x20 => 'keyEncipherment',
@@ -1786,6 +1795,6 @@
 							}
 					}
-			}	
-		return $dados;			
+			}
+		return $dados;
 	}
 
@@ -1806,7 +1815,7 @@
 				}
 			}
-		return $dados;			
-	}
-	
+		return $dados;
+	}
+
 function BASICCONSTRAINTS($xx, $certificado_digital_formato_der)
 	{
@@ -1820,11 +1829,11 @@
 					}
 			}
-		return $dados;			
-	}
-	
+		return $dados;
+	}
+
 function recupera_dados_do_ceritificado_digital($certificado_digital_formato_pem)
 	{
 		$cert_der =  pem2der($certificado_digital_formato_pem);
-		
+
 		$funcoes = array(SERIALNUMBER => 1,
 					ISSUER => 3,
@@ -1837,9 +1846,9 @@
 					CRLDistributionPoints =>  $cert_der,
 					subjectAltName => $cert_der);
-			   
+
 		$dados=array();
-		
+
 		$cert_data = Crl_parseASN( $cert_der);
-		
+
 		foreach($funcoes as $funcao => $parametro)
 			{
@@ -1854,5 +1863,5 @@
 					}
 			}
-		return $dados;		
+		return $dados;
 	}
 
Index: /branches/2.2/security/vercert.php
===================================================================
--- /branches/2.2/security/vercert.php	(revision 3232)
+++ /branches/2.2/security/vercert.php	(revision 3984)
@@ -1,95 +1,3 @@
 <?php
-function item_para_uid($dados_do_certificado)
-	{
-/*
-// Exemplo do Array $dados_do_certificado padrao ICP-BRASIL
-// O conteudo do array pode variar conforme a AC emissora.
-Array
-(
-    [SERIALNUMBER] => 2009031816232802
-    [EMISSOR_CAMINHO_COMPLETO] => Array
-        (
-            [C] => BR
-            [O] => ICP-Brasil
-            [OU] => CSPB-1
-            [CN] => HOMAutoridade Certificadora do SERPRO Final v2
-        )
-
-    [EMISSOR] => HOMAutoridade Certificadora do SERPRO Final v2
-    [INICIO_VALIDADE] => 20090318205216
-    [FIM_VALIDADE] => 20120317205216
-    [EXPIRADO] =>
-    [SUBJECT] => Array
-        (
-            [C] => BR
-            [O] => ICP-Brasil
-            [OU] => Pessoa Fisica A3
-            [CN] => CESAR VIANNA
-        )
-
-    [NOME] => CESAR VIANNA
-    [AUTHORITYKEYIDENTIFIER] => AE34F397BB05B1AA6CC3FD6C4F0E9129BBB61BE2
-    [KEYUSAGE] => Array
-        (
-            [digitalSignature] => 1
-            [nonRepudiation] => 1
-            [keyEncipherment] => 1
-        )
-
-    [EXTKEYUSAGE] => Array
-        (
-            [clientAuth] => 1.3.6.1.5.5.7.3.2
-            [emailProtection] => 1.3.6.1.5.5.7.3.4
-        )
-
-    [CA] =>
-    [CRLDISTRIBUTIONPOINTS] => Array
-        (
-            [0] => http://ccdhom.serpro.gov.br/lcr/serproacfv2.crl
-            [1] => http://ccdhom.serpro.gov.br/lcr/serproacfv3.crl
-            [2] => http://ccdhom.serpro.gov.br/lcr/serproacfv4.crl
-        )
-
-    [2.16.76.1.3.6] => Array
-        (
-            [CADINSS] => 000000000000
-        )
-
-    [CADINSS] => 000000000000
-    [2.16.76.1.3.5] => Array
-        (
-            [TITULO] => 000000000000
-            [ZONA] => 000
-            [SECAO] => 0000
-            [TITULO_CIDADE_UF] =>
-        )
-
-    [TITULO] => 000000000000
-    [ZONA] => 000
-    [SECAO] => 0000
-    [TITULO_CIDADE_UF] =>
-    [2.16.76.1.3.1] => Array
-        (
-            [NASCIMENTO] => 19081981
-            [CPF] => 12345678902
-            [NIS] => 12345678901
-            [RG] => 000201075150953
-            [ORGAOUF] => SSPRS
-        )
-
-    [NASCIMENTO] => 19081981
-    [CPF] =>  12345678902
-    [NIS] => 12345678901
-    [RG] => 000201075150953
-    [ORGAOUF] => SSPRS
-    [EMAIL] => cesar.vianna@pr.planalto.gov.br
-)
-*/
-
-		// Retorna o CPF para usar como uid.
-		return $dados_do_certificado['2.16.76.1.3.1']['CPF'];
-	}
-
-
 $GLOBALS['phpgw_info']['flags'] = array(
 		'disable_Template_class' => True,
@@ -118,16 +26,4 @@
 require_once('classes/Verifica_Certificado.php');
 include('classes/Verifica_Certificado_conf.php');
-
-  # Transforma o certificado do formato PEM para o formato DER ...
-  function troca_espaco_por_mais($pem_data)
-  {
-    $begin = "CERTIFICATE-----";
-    $end   = "-----END";
-    $aux = substr($pem_data, strpos($pem_data, $begin)+strlen($begin));
-    $aux = substr($aux, 0, strpos($aux, $end));
-    $aux = strtr($aux,' ','+');
-    $aux = '-----BEGIN CERTIFICATE-----'.$aux.'-----END CERTIFICATE-----';
-    return $aux;
-  }
 
 $cert =str_replace(chr(0x0A).chr(0x0A),chr(0x0A),$_REQUEST['certificado']);
@@ -184,14 +80,14 @@
      }
      
-    $filtro = 'uid='. item_para_uid($c->dados);
+    $filtro = 'uid='. $c->dados['2.16.76.1.3.1']['CPF'];
     $atributos = array();
-    //$atributos[] = 'phpgwaccountexpires';
-    $atributos[] = 'phpgwlastpasswdchange';
-
-    if(isset($GLOBALS['phpgw_info']['server']['atributoexpiracao']))
-		{
-		    $atributos[] = $GLOBALS['phpgw_info']['server']['atributoexpiracao'];
-		}
-
+    if(isset($GLOBALS['phpgw_info']['server']['atributoexpiracao']) && $GLOBALS['phpgw_info']['server']['atributoexpiracao'])
+        {
+            $atributos[] = $GLOBALS['phpgw_info']['server']['atributoexpiracao'];
+        }
+    else
+        {
+            $atributos[] = 'phpgwlastpasswdchange';
+        }
      $atributos[] = "usercertificate";
      $atributos[] = "phpgwaccountstatus";
@@ -231,5 +127,5 @@
 			$aux1 = $info[0]["dn"];
 			$user_info['usercertificate'] = $cert;
-			if(isset($GLOBALS['phpgw_info']['server']['atributoexpiracao']))
+			if(isset($GLOBALS['phpgw_info']['server']['atributoexpiracao']) && $GLOBALS['phpgw_info']['server']['atributoexpiracao'])
 				{
 					if(substr($info[0][$GLOBALS['phpgw_info']['server']['atributoexpiracao']][0],-1,1)=="Z")
